# mapResponseEntity

@@@ div { .group-scala }

## Signature

@@signature [BasicDirectives.scala]($akka-http$/akka-http/src/main/scala/akka/http/scaladsl/server/directives/BasicDirectives.scala) { #mapResponseEntity }

@@@

## Description

The `mapResponseEntity` directive is used as a building block for @ref[Custom Directives](../custom-directives.md) to transform a
response entity that was generated by the inner route.

See @ref[Response Transforming Directives](index.md#response-transforming-directives) for similar directives.

## Example

Scala
:  @@snip [BasicDirectivesExamplesSpec.scala]($test$/scala/docs/http/scaladsl/server/directives/BasicDirectivesExamplesSpec.scala) { #mapResponseEntity }

Java
:  @@snip [BasicDirectivesExamplesTest.java]($test$/java/docs/http/javadsl/server/directives/BasicDirectivesExamplesTest.java) { #mapResponseEntity }
